unit UniwersalnyCz1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite, ExtCtrls, StdCtrls, OmegaSurface;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    GroupBox1: TGroupBox;
    OmegaSurface1: TOmegaSurface;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Label1: TLabel;
    RadioGroup2: TRadioGroup;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    ComboBox2: TComboBox;
    Button3: TButton;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Klatka:integer;
implementation
uses OmegaZolnierz;
{$R *.DFM}

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 if not omegascreen1.CanDraw then exit;
 OmegaSurface1.BeginRender;
  OmegaScreen1.ClearScreen(0,0,128,0);
  OmegaSprite1.Draw;
  OmegaSprite1.Move(OmegaTimer1.DeltaSecs);
 OmegaSurface1.EndRender;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaSurface1.SethWnd(Panel1.handle);
  OmegaSurface1.Width:=PAnel1.Width;
  OmegaSurface1.Height:=PAnel1.Height;
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',10,[]);
  OmegaFont1.Color:=OmegaColor(0,200,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
end;

procedure TForm1.FormShow(Sender: TObject);
var
 i:integer;
begin
 ComboBox1.Clear;

 for i:=0 to OmegaImageList1.ImageList.Count-1 do
             ComboBox1.Items.Add(OmegaImageList1.ImageList.Items[i].Name);
 ComboBox1.ItemIndex:=0;
 //zaaduj poczatkowy stan obrazu
 Image1.Picture.Assign(OmegaImageList1.ImageList.Items[ComboBox1.ItemIndex].Picture);
 Image1.Width :=OmegaImageList1.ImageList.Items[ComboBox1.ItemIndex].ImageWidth;
 Image1.Height:=OmegaImageList1.ImageList.Items[ComboBox1.ItemIndex].ImageHeight;

 //tworz zolnierza
 Zolnierz:=TZolnierz.Create(OmegaSprite1,OmegaImageList1);
 with TZolnierz(Zolnierz) do begin
      x:=(OmegaSurface1.width -Image.TileWidth ) div 2-16;
      y:=(OmegaSurface1.height-Image.TileHeight) div 2-8;
 end;
 OmegaTimer1.Enabled:=true;
end;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
  OmegaSurface1.Width:=PAnel1.Width;
  OmegaSurface1.Height:=PAnel1.Height;
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
   if ComboBox1.ItemIndex<0 then exit;
   Image1.Picture.Assign(OmegaImageList1.ImageList.Items[ComboBox1.ItemIndex].Picture);
   Image1.Width :=OmegaImageList1.ImageList.Items[ComboBox1.ItemIndex].ImageWidth;
   Image1.Height:=OmegaImageList1.ImageList.Items[ComboBox1.ItemIndex].ImageHeight;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Klatka:=(y div 32)*12;//tylko pierwsza kolumna
   //uaktualnij Zonierza
   with TZolnierz(Zolnierz) do begin
        UstawObraz(ComboBox1.ItemIndex,ComboBox1.ItemIndex,Klatka);
   end;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  case RadioGroup2.ItemIndex of
   0:begin OmegaSurface1.OmegaScreen.ScaleX:=1;
           OmegaSurface1.OmegaScreen.ScaleY:=1;end;
   1:begin OmegaSurface1.OmegaScreen.ScaleX:=2;
           OmegaSurface1.OmegaScreen.ScaleY:=2;end;
   2:begin OmegaSurface1.OmegaScreen.ScaleX:=4;
           OmegaSurface1.OmegaScreen.ScaleY:=4;end;
  end;
 with TZolnierz(Zolnierz) do begin
      x:=Round((OmegaSurface1.width -Image.TileWidth )/OmegaSurface1.OmegaScreen.ScaleX) div 2-16;
      y:=Round((OmegaSurface1.height-Image.TileHeight)/OmegaSurface1.OmegaScreen.ScaleY) div 2-8;
 end;

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 case RadioGroup1.ItemIndex of
    0:TZolnierz(Zolnierz).OffSetKierunku:=0;//na pnoc
    1:TZolnierz(Zolnierz).OffSetKierunku:=3;//na poludnie
    2:TZolnierz(Zolnierz).OffSetKierunku:=6;//na zachd
    3:TZolnierz(Zolnierz).OffSetKierunku:=9;//na wschd
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  s:string;
begin
  //dodaj posta do listy
  s:=IntToStr(TZolnierz(Zolnierz).IdKlatkaKorpus)+' '+
     IntToStr(TZolnierz(Zolnierz).IdKlatkaGlowa)+' '+
     IntToStr(TZolnierz(Zolnierz).IdKlatkaBron)+' '+
     IntToStr(TZolnierz(Zolnierz).IdKlatkaTarcza);
  ComboBox2.Items.Add(s);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  //usu posta z listy
  if ComboBox2.Items.Count<1 then exit;
  ComboBox2.Items.Delete(ComboBox2.ItemIndex);
end;

procedure TForm1.ComboBox2Click(Sender: TObject);
var
 s:array[0..3]of string;
 ss:string;
 k,i:byte;
begin
  //zaaduj biezcy model postaci
  If ComboBox2.Items.Count<1 then exit;
  i:=0;
  k:=0;
  while i<=length(ComboBox2.Items.Strings[ComboBox2.ItemIndex]) do begin
   //czy spacja lub koniec ciagu znakow
   if (ComboBox2.Items.Strings[ComboBox2.ItemIndex][i]=' ')
      or (i=length(ComboBox2.Items.Strings[ComboBox2.ItemIndex]))
   then begin
      s[k]:=TrimRight(ss);ss:='';
      inc(k);
   end;
   inc(i);
   ss:=ss+ComboBox2.Items.Strings[ComboBox2.ItemIndex][i];
  end;
  with TZolnierz(Zolnierz)do begin
     IdKlatkaKorpus:=StrToInt(s[0]);
     IdKlatkaGlowa :=StrToInt(s[1]);
     IdKlatkaBron  :=StrToInt(s[2]);
     IdKlatkaTarcza:=StrToInt(s[3]);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ExtractFilePath(ParamStr(0));
  if SaveDialog1.Execute then
  ComboBox2.Items.SaveToFile(SaveDialog1.FileName);
end;

end.
